Subject: Re: [Megaco] v2 mismatch ABNF & ASN.1 IndAudmediaParm?

From: Christian Groves <[email-masked]>
Date: Mon, 23 Jun 2003 13:53:14 +1000

Hello Aleksandr,

See below.

Christian

Aleksandr Ryabin wrote:
> Hi Christian,
> 
> I'm not sure on your usage of "whole" and "individual".
> They are complimentary: each SDP is "individual" and it is a "whole".
> I said "whole" SDP, not "whole" MediaDescriptor.
[CHG] Well no use arguing about personal interpretations maybe its the 
difference between US english, International english and Australian english :).

> 
> What I'm trying to understand is:
> How can MGC do an audit to get *only* whole local (or remote) SDP and 
> nothing else?
[CHG] No

> My understanding current ABNF syntax does not allow it.
> Do we agree on this?
[CHG] Yes

> 
> If yes, is it useful to have such a functionality? I think yes.
> Do we agree on this?
[CHG] I don't oppose adding this if its wanted.

> 
> If yes, does my proposal below solves the request? I think yes.
> Do we agree on this?
[CHG] Yes

> 
> If yes, how do we go about adding it into IG/or next version?
> Opinions?
[CHG] Next version would enable the syntax change to be identified. Without 
breaking things.

> 
> Thanks
>         Aleks
> 
> At 10:22 PM 6/18/2003, Christian Groves wrote:
> 
>> Hello Aleksandr,
>>
>> You said "whole" local or remote descriptor MediaToken allows that. It 
>> does not
>> allow "individual" local and remote descriptors.
>>
>> Regards, Christian
>>
>> Aleksandr Ryabin wrote:
>> >
>> > Hi Christian,
>> >
>> > Could you please clarify on how would MGC audit individual local, or
>> > remote SDP with v1? I mean, local and remote SDPs are part of
>> > larger MediaDescriptor and the ABNF construction of auditItem
>> > only allows auditing the whole MediaDescriptor, not parts of it:
>> >
>> >        ;at-most-once, and DigitMapToken and PackagesToken are not 
>> allowed
>> >        ;in AuditCapabilities command
>> >        auditItem            = ( MuxToken / ModemToken / MediaToken /
>> >                                SignalsToken / EventBufferToken /
>> >                                DigitMapToken / StatsToken / 
>> EventsToken /
>> >                                ObservedEventsToken / PackagesToken )
>> >
>> > So, if I understand it correctly, MGC can only audit the whole
>> > MediaDescriptor, not individual local, or remote SDP.
>> >
>> > Regards,
>> >          Aleks
>> >
>> > At 11:59 PM 6/17/2003, Christian Groves wrote:
>> > >Hello Aleksandr,
>> > >
>> > >Megaco does allow you to audit a whole local or remote descriptor. 
>> This is the
>> > >audit capability v1. Individual auditing was added in v2. We didn't 
>> add
>> > >individual audit of a whole descriptor as this would duplicate 
>> functionality.
>> > >
>> > >It was decided not to allow auditing of individual segments of 
>> local and
>> > >remote
>> > >SDP (text encoding) because no body could come up with an appropriate
>> > >method to
>> > >do this and didn't know what the reply looked like. For the binary 
>> encoding it
>> > >was very easy because all parameters follow a tag length value 
>> structure. You
>> > >request the tag and you get back the value.
>> > >
>> > >Christian
>> > >
>> > >Aleksandr Ryabin wrote:
>> > > >
>> > > > Hi,
>> > > >
>> > > > While we are on topic. The following does not allow auditing for 
>> the whole
>> > > > local or remote SDP in ABNF:
>> > > >          ; at-most-once
>> > > >          indAudstreamParm = ( indAudlocalControlDescriptor )
>> > > >          ; SDP too complex to pull out individual pieces for audit,
>> > > >          ; hence no individual audit for Local and Remote
>> > > >
>> > > > The question is why? I mean why does not it allow to audit *whole*
>> > > > local or remote SDP? E.g.:
>> > > >          indAudstreamParm = ( indAudlocalControlDescriptor / 
>> LocalToken /
>> > > > RemoteToken)
>> > > >
>> > > > BTW ASN.1 does allow that, as well as individual pieces of SDPs.
>> > > >
>> > > > Thanks
>> > > >          Aleks
>> > > >
>> > > > PS. Small nit in indAudauditReturnParameter (two slashes at the 
>> end):
>> > > >        indAudauditReturnParameter = (indAudmediaDescriptor / /
>> > > >
>> > > > At 03:30 PM 6/17/2003, Kevin Boyle wrote:
>> > > > >Aha... I see the problem now.  In binary, you can request info 
>> about
>> > > several
>> > > > >streams at once, but you may only request info about one stream in
>> > > text.  Is
>> > > > >this an accurate summary?
>> > > > >
>> > > > >Seeing as this would be a syntax change, we need to know if 
>> anyone would
>> > > > >have major heartburn over changing the syntax to fix this.  If 
>> not, I will
>> > > > >draft up an IG item to fix this...
>> > > > >
>> > > > >Speaking personally, I think this is a beneficial change, 
>> because it makes
>> > > > >the syntax align between the expression of items within the media
>> > > > >descriptor, and the audit of items within the media descriptor, 
>> as well as
>> > > > >making both binary and text align in capability.
>> > > > >
>> > > > >Any other comments?
>> > > > >
>> > > > >Kevin
>> > > > >
>> > > > >-----Original Message-----
>> > > > >From: Micael Karlberg [mailto:[email-masked]]
>> > > > >Sent: Tuesday, June 17, 2003 1:26 PM
>> > > > >To: Christian Groves
>> > > > >Cc: [email-masked]
>> > > > >Subject: Re: [Megaco] v2 mismatch ABNF & ASN.1 IndAudmediaParm?
>> > > > >
>> > > > >
>> > > > >Hello Christian,
>> > > > >
>> > > > >Christian Groves writes:
>> > > > >  > Hello Micael,
>> > > > >  >
>> > > > >  > I don't understand what the problem is nor the comments in the
>> > > ASN.1 you
>> > > > >are  > referring to?
>> > > > >
>> > > > >The comment ("at-most-once per item...") is in the ABNF.
>> > > > >
>> > > > >  > If you are referring to the ::= SEQUENCE this is actually 
>> an ASN.1  >
>> > > > >construct that says that a sequence of information elements may be
>> > > encoded,
>> > > > >in  > this case "termStateDescr" & a choice of streams.
>> > > > >
>> > > > >This is how see it also.
>> > > > >
>> > > > >  > This same information is represented by the ABNF.
>> > > > >
>> > > > >This I _cannot_ find!
>> > > > >
>> > > > >The comment in the ABNF seems to indicate that it should be as in
>> > > > >the ASN.1 but the ABNF definition of the indAudmediaDescriptor
>> > > > >allow for only one value of indAudmediaParm.
>> > > > >
>> > > > >Therefor my _question_ if the definition should'nt really be:
>> > > > >
>> > > > >         indAudmediaDescriptor = MediaToken LBRKT indAudmediaParm
>> > > > >                                  *(COMMA indAudmediaParm) RBRKT
>> > > > >
>> > > > >Also, the defintion of the mediaDescriptor strikes me as _very_ 
>> similar to
>> > > > >my "proposal":
>> > > > >
>> > > > >       mediaDescriptor = MediaToken LBRKT mediaParm
>> > > > >                         *(COMMA mediaParm) RBRKT
>> > > > >
>> > > > >       ; at-most one terminationStateDescriptor
>> > > > >       ; and either streamParm(s) or streamDescriptor(s) but 
>> not both
>> > > > >       mediaParm = (streamParm / streamDescriptor /
>> > > > >                     terminationStateDescriptor)
>> > > > >
>> > > > >Regards,
>> > > > >         /BMK
>> > > > >
>> > > > >  >
>> > > > >  > Regards, Christian
>> > > > >  >
>> > > > >  > Micael Karlberg wrote:
>> > > > >  > >
>> > > > >  > > Hi,
>> > > > >  > >
>> > > > >  > > In draft-ietf-megaco-h248v2-04.txt there appear to be a
>> > > mismatch  > >
>> > > > >between the ABNF and the ASN.1 regarding 
>> indAudmediaDescriptor.  > > My
>> > > > >question is: Should the definition of ABNF 
>> indAudmediaDescriptor  > >
>> > > really
>> > > > >be:  > >
>> > > > >  > >       indAudmediaDescriptor   = MediaToken LBRKT 
>> indAudmediaParm
>> > > > >  > >                                 *(COMMA indAudmediaParm) 
>> RBRKT
>> > > > >  > >
>> > > > >  > > The comment for indAudmediaParm and the ASN.1
>> > > IndAudMediaDescriptor  >
>> > > > > > indicates that it should be a list. Or am I missing 
>> something?  > >
>> > > > >  > > Also, see definition of mediaDescriptor!
>> > > > >  > >
>> > > > >  > > ABNF:
>> > > > >  > > ----
>> > > > >  > >       indAudmediaDescriptor   = MediaToken LBRKT 
>> indAudmediaParm
>> > > RBRKT
>> > > > >  > >
>> > > > >  > >       ; at-most-once per item
>> > > > >  > >       ; and either streamParm or streamDescriptor but not 
>> both
>> > > > >  > >       indAudmediaParm = (indAudstreamParm / 
>> indAudstreamDescriptor /
>> > > > >  > >                          indAudterminationStateDescriptor)
>> > > > >  > >
>> > > > >  > > ASN.1:
>> > > > >  > > -----
>> > > > >  > >       IndAudMediaDescriptor ::= SEQUENCE
>> > > > >  > >       {
>> > > > >  > >
>> > > > >  > >          termStateDescr    IndAudTerminationStateDescriptor
>> > > OPTIONAL,
>> > > > >  > >          streams  CHOICE
>> > > > >  > >                {
>> > > > >  > >                   oneStream      IndAudStreamParms,
>> > > > >  > >                   multiStream    SEQUENCE OF 
>> IndAudStreamDescriptor
>> > > > >  > >                } OPTIONAL,
>> > > > >  > >          ...
>> > > > >  > >       }
>> > > > >  > >
>> > > > >  > > Regards,
>> > > > >  > >         /BMK
>> > > > >  > >
>> > > > >  > > _______________________________________________
>> > > > >  > > Megaco mailing list
>> > > > >  > > [email-masked]
>> > > > >  > > https://www1.ietf.org/mailman/listinfo/megaco
>> > > > >
>> > > > >--
>> > > > >Micael Karlberg          Ericsson AB, Älvsjö Sweden
>> > > > >Tel:  +46 8 727 5668     EAB/UHK/KD - OTP Product Development
>> > > > >ECN:  851 5668           Mail: [email-masked]
>> > > > >Fax:  +46 8 727 5775
>> > > > >
>> > > > >_______________________________________________
>> > > > >Megaco mailing list
>> > > > >[email-masked]
>> > > > >https://www1.ietf.org/mailman/listinfo/megaco
>> > > > >
>> > > > >_______________________________________________
>> > > > >Megaco mailing list
>> > > > >[email-masked]
>> > > > >https://www1.ietf.org/mailman/listinfo/megaco
> 
> 

_______________________________________________
Megaco mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/megaco